Join machine
curl --request POST \
--url https://levers9.uselevers.com/machines/join \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"joinToken": "<string>",
"machineFingerprint": "<string>",
"hostname": "<string>",
"os": "<string>",
"arch": "<string>",
"cpuCount": 123,
"memoryMb": "<string>",
"gpu": [
"<string>"
],
"gpuCount": 123,
"preflight": [
{
"name": "<string>",
"ok": true,
"message": "<string>",
"severity": "<string>"
}
],
"schedulable": true,
"executor": "<string>",
"cpuMillicores": "<string>",
"gpuIds": [
"<string>"
],
"networkSlotPoolSize": 123,
"containerStartConcurrency": 123,
"workerImage": "<string>",
"capabilities": [
"<string>"
]
}
'import requests
url = "https://levers9.uselevers.com/machines/join"
payload = {
"joinToken": "<string>",
"machineFingerprint": "<string>",
"hostname": "<string>",
"os": "<string>",
"arch": "<string>",
"cpuCount": 123,
"memoryMb": "<string>",
"gpu": ["<string>"],
"gpuCount": 123,
"preflight": [
{
"name": "<string>",
"ok": True,
"message": "<string>",
"severity": "<string>"
}
],
"schedulable": True,
"executor": "<string>",
"cpuMillicores": "<string>",
"gpuIds": ["<string>"],
"networkSlotPoolSize": 123,
"containerStartConcurrency": 123,
"workerImage": "<string>",
"capabilities": ["<string>"]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
joinToken: '<string>',
machineFingerprint: '<string>',
hostname: '<string>',
os: '<string>',
arch: '<string>',
cpuCount: 123,
memoryMb: '<string>',
gpu: ['<string>'],
gpuCount: 123,
preflight: [{name: '<string>', ok: true, message: '<string>', severity: '<string>'}],
schedulable: true,
executor: '<string>',
cpuMillicores: '<string>',
gpuIds: ['<string>'],
networkSlotPoolSize: 123,
containerStartConcurrency: 123,
workerImage: '<string>',
capabilities: ['<string>']
})
};
fetch('https://levers9.uselevers.com/machines/join', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://levers9.uselevers.com/machines/join",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'joinToken' => '<string>',
'machineFingerprint' => '<string>',
'hostname' => '<string>',
'os' => '<string>',
'arch' => '<string>',
'cpuCount' => 123,
'memoryMb' => '<string>',
'gpu' => [
'<string>'
],
'gpuCount' => 123,
'preflight' => [
[
'name' => '<string>',
'ok' => true,
'message' => '<string>',
'severity' => '<string>'
]
],
'schedulable' => true,
'executor' => '<string>',
'cpuMillicores' => '<string>',
'gpuIds' => [
'<string>'
],
'networkSlotPoolSize' => 123,
'containerStartConcurrency' => 123,
'workerImage' => '<string>',
'capabilities' => [
'<string>'
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://levers9.uselevers.com/machines/join"
payload := strings.NewReader("{\n \"joinToken\": \"<string>\",\n \"machineFingerprint\": \"<string>\",\n \"hostname\": \"<string>\",\n \"os\": \"<string>\",\n \"arch\": \"<string>\",\n \"cpuCount\": 123,\n \"memoryMb\": \"<string>\",\n \"gpu\": [\n \"<string>\"\n ],\n \"gpuCount\": 123,\n \"preflight\": [\n {\n \"name\": \"<string>\",\n \"ok\": true,\n \"message\": \"<string>\",\n \"severity\": \"<string>\"\n }\n ],\n \"schedulable\": true,\n \"executor\": \"<string>\",\n \"cpuMillicores\": \"<string>\",\n \"gpuIds\": [\n \"<string>\"\n ],\n \"networkSlotPoolSize\": 123,\n \"containerStartConcurrency\": 123,\n \"workerImage\": \"<string>\",\n \"capabilities\": [\n \"<string>\"\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://levers9.uselevers.com/machines/join")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"joinToken\": \"<string>\",\n \"machineFingerprint\": \"<string>\",\n \"hostname\": \"<string>\",\n \"os\": \"<string>\",\n \"arch\": \"<string>\",\n \"cpuCount\": 123,\n \"memoryMb\": \"<string>\",\n \"gpu\": [\n \"<string>\"\n ],\n \"gpuCount\": 123,\n \"preflight\": [\n {\n \"name\": \"<string>\",\n \"ok\": true,\n \"message\": \"<string>\",\n \"severity\": \"<string>\"\n }\n ],\n \"schedulable\": true,\n \"executor\": \"<string>\",\n \"cpuMillicores\": \"<string>\",\n \"gpuIds\": [\n \"<string>\"\n ],\n \"networkSlotPoolSize\": 123,\n \"containerStartConcurrency\": 123,\n \"workerImage\": \"<string>\",\n \"capabilities\": [\n \"<string>\"\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://levers9.uselevers.com/machines/join")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"joinToken\": \"<string>\",\n \"machineFingerprint\": \"<string>\",\n \"hostname\": \"<string>\",\n \"os\": \"<string>\",\n \"arch\": \"<string>\",\n \"cpuCount\": 123,\n \"memoryMb\": \"<string>\",\n \"gpu\": [\n \"<string>\"\n ],\n \"gpuCount\": 123,\n \"preflight\": [\n {\n \"name\": \"<string>\",\n \"ok\": true,\n \"message\": \"<string>\",\n \"severity\": \"<string>\"\n }\n ],\n \"schedulable\": true,\n \"executor\": \"<string>\",\n \"cpuMillicores\": \"<string>\",\n \"gpuIds\": [\n \"<string>\"\n ],\n \"networkSlotPoolSize\": 123,\n \"containerStartConcurrency\": 123,\n \"workerImage\": \"<string>\",\n \"capabilities\": [\n \"<string>\"\n ]\n}"
response = http.request(request)
puts response.read_body{
"ok": true,
"errMsg": "<string>",
"workspaceId": "<string>",
"poolName": "<string>",
"machineId": "<string>",
"machineToken": "<string>",
"bootstrap": {
"controlplaneHttpUrl": "<string>",
"controlplaneGrpcHost": "<string>",
"controlplaneGrpcPort": 123,
"controlplaneGrpcTls": true,
"workspaceId": "<string>",
"poolName": "<string>",
"transport": "<string>",
"executor": "<string>",
"fallback": "<string>",
"disabledServices": [
"<string>"
],
"imageRegistryStore": "<string>",
"imageClipVersion": 123,
"imageLocalCacheEnabled": true,
"telemetry": {
"enabled": true,
"streamPrefix": "<string>",
"logs": {
"destination": "<string>",
"credential": "<string>",
"streamPrefix": "<string>"
},
"events": {
"destination": "<string>",
"credential": "<string>",
"streamPrefix": "<string>"
}
},
"billing": {
"usageEndpoint": "<string>",
"usageToken": "<string>",
"costHookEndpoint": "<string>",
"costHookToken": "<string>",
"billableMarginPct": 123
}
}
}{
"code": 123,
"message": "<string>",
"details": [
{
"@type": "<string>"
}
]
}ControlPlaneService
Join machine
POST
/
machines
/
join
Join machine
curl --request POST \
--url https://levers9.uselevers.com/machines/join \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"joinToken": "<string>",
"machineFingerprint": "<string>",
"hostname": "<string>",
"os": "<string>",
"arch": "<string>",
"cpuCount": 123,
"memoryMb": "<string>",
"gpu": [
"<string>"
],
"gpuCount": 123,
"preflight": [
{
"name": "<string>",
"ok": true,
"message": "<string>",
"severity": "<string>"
}
],
"schedulable": true,
"executor": "<string>",
"cpuMillicores": "<string>",
"gpuIds": [
"<string>"
],
"networkSlotPoolSize": 123,
"containerStartConcurrency": 123,
"workerImage": "<string>",
"capabilities": [
"<string>"
]
}
'import requests
url = "https://levers9.uselevers.com/machines/join"
payload = {
"joinToken": "<string>",
"machineFingerprint": "<string>",
"hostname": "<string>",
"os": "<string>",
"arch": "<string>",
"cpuCount": 123,
"memoryMb": "<string>",
"gpu": ["<string>"],
"gpuCount": 123,
"preflight": [
{
"name": "<string>",
"ok": True,
"message": "<string>",
"severity": "<string>"
}
],
"schedulable": True,
"executor": "<string>",
"cpuMillicores": "<string>",
"gpuIds": ["<string>"],
"networkSlotPoolSize": 123,
"containerStartConcurrency": 123,
"workerImage": "<string>",
"capabilities": ["<string>"]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
joinToken: '<string>',
machineFingerprint: '<string>',
hostname: '<string>',
os: '<string>',
arch: '<string>',
cpuCount: 123,
memoryMb: '<string>',
gpu: ['<string>'],
gpuCount: 123,
preflight: [{name: '<string>', ok: true, message: '<string>', severity: '<string>'}],
schedulable: true,
executor: '<string>',
cpuMillicores: '<string>',
gpuIds: ['<string>'],
networkSlotPoolSize: 123,
containerStartConcurrency: 123,
workerImage: '<string>',
capabilities: ['<string>']
})
};
fetch('https://levers9.uselevers.com/machines/join', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://levers9.uselevers.com/machines/join",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'joinToken' => '<string>',
'machineFingerprint' => '<string>',
'hostname' => '<string>',
'os' => '<string>',
'arch' => '<string>',
'cpuCount' => 123,
'memoryMb' => '<string>',
'gpu' => [
'<string>'
],
'gpuCount' => 123,
'preflight' => [
[
'name' => '<string>',
'ok' => true,
'message' => '<string>',
'severity' => '<string>'
]
],
'schedulable' => true,
'executor' => '<string>',
'cpuMillicores' => '<string>',
'gpuIds' => [
'<string>'
],
'networkSlotPoolSize' => 123,
'containerStartConcurrency' => 123,
'workerImage' => '<string>',
'capabilities' => [
'<string>'
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://levers9.uselevers.com/machines/join"
payload := strings.NewReader("{\n \"joinToken\": \"<string>\",\n \"machineFingerprint\": \"<string>\",\n \"hostname\": \"<string>\",\n \"os\": \"<string>\",\n \"arch\": \"<string>\",\n \"cpuCount\": 123,\n \"memoryMb\": \"<string>\",\n \"gpu\": [\n \"<string>\"\n ],\n \"gpuCount\": 123,\n \"preflight\": [\n {\n \"name\": \"<string>\",\n \"ok\": true,\n \"message\": \"<string>\",\n \"severity\": \"<string>\"\n }\n ],\n \"schedulable\": true,\n \"executor\": \"<string>\",\n \"cpuMillicores\": \"<string>\",\n \"gpuIds\": [\n \"<string>\"\n ],\n \"networkSlotPoolSize\": 123,\n \"containerStartConcurrency\": 123,\n \"workerImage\": \"<string>\",\n \"capabilities\": [\n \"<string>\"\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://levers9.uselevers.com/machines/join")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"joinToken\": \"<string>\",\n \"machineFingerprint\": \"<string>\",\n \"hostname\": \"<string>\",\n \"os\": \"<string>\",\n \"arch\": \"<string>\",\n \"cpuCount\": 123,\n \"memoryMb\": \"<string>\",\n \"gpu\": [\n \"<string>\"\n ],\n \"gpuCount\": 123,\n \"preflight\": [\n {\n \"name\": \"<string>\",\n \"ok\": true,\n \"message\": \"<string>\",\n \"severity\": \"<string>\"\n }\n ],\n \"schedulable\": true,\n \"executor\": \"<string>\",\n \"cpuMillicores\": \"<string>\",\n \"gpuIds\": [\n \"<string>\"\n ],\n \"networkSlotPoolSize\": 123,\n \"containerStartConcurrency\": 123,\n \"workerImage\": \"<string>\",\n \"capabilities\": [\n \"<string>\"\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://levers9.uselevers.com/machines/join")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"joinToken\": \"<string>\",\n \"machineFingerprint\": \"<string>\",\n \"hostname\": \"<string>\",\n \"os\": \"<string>\",\n \"arch\": \"<string>\",\n \"cpuCount\": 123,\n \"memoryMb\": \"<string>\",\n \"gpu\": [\n \"<string>\"\n ],\n \"gpuCount\": 123,\n \"preflight\": [\n {\n \"name\": \"<string>\",\n \"ok\": true,\n \"message\": \"<string>\",\n \"severity\": \"<string>\"\n }\n ],\n \"schedulable\": true,\n \"executor\": \"<string>\",\n \"cpuMillicores\": \"<string>\",\n \"gpuIds\": [\n \"<string>\"\n ],\n \"networkSlotPoolSize\": 123,\n \"containerStartConcurrency\": 123,\n \"workerImage\": \"<string>\",\n \"capabilities\": [\n \"<string>\"\n ]\n}"
response = http.request(request)
puts response.read_body{
"ok": true,
"errMsg": "<string>",
"workspaceId": "<string>",
"poolName": "<string>",
"machineId": "<string>",
"machineToken": "<string>",
"bootstrap": {
"controlplaneHttpUrl": "<string>",
"controlplaneGrpcHost": "<string>",
"controlplaneGrpcPort": 123,
"controlplaneGrpcTls": true,
"workspaceId": "<string>",
"poolName": "<string>",
"transport": "<string>",
"executor": "<string>",
"fallback": "<string>",
"disabledServices": [
"<string>"
],
"imageRegistryStore": "<string>",
"imageClipVersion": 123,
"imageLocalCacheEnabled": true,
"telemetry": {
"enabled": true,
"streamPrefix": "<string>",
"logs": {
"destination": "<string>",
"credential": "<string>",
"streamPrefix": "<string>"
},
"events": {
"destination": "<string>",
"credential": "<string>",
"streamPrefix": "<string>"
}
},
"billing": {
"usageEndpoint": "<string>",
"usageToken": "<string>",
"costHookEndpoint": "<string>",
"costHookToken": "<string>",
"billableMarginPct": 123
}
}
}{
"code": 123,
"message": "<string>",
"details": [
{
"@type": "<string>"
}
]
}Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
Body
application/json
Show child attributes
Show child attributes
Optional per-machine worker image override. The controlplane remembers the generated value as a baseline so untouched installs continue to follow future image tag changes while manually edited values remain pinned.

